package rm;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.reportmill.base.*;
import com.reportmill.shape.*;
import snap.util.*;

public class Product {

    // The product name
    public String    productName;
    
    // The product tag line
    public String    tagLine;
    
    // The product copy
    public String    copy;
    
    // The price
    public float     price;
    
    // The part number
    public String    partNumber;
    
    // The string path to the produce image
    public String    imagePath;
    
    // The layout (Full Page, Half Page, etc.)
    public String    layout;
    
    // THe table row version
    public String    tableRowVersion;

// The list of all products
static List _products;

// A randomizer
static Random _random = new Random();

static public List products(HttpServletRequest request)
{
    // Initialize video lists
    if(_products==null) {
        String path = rootPath(request);
        String file = SnapUtils.getBytes(path + "/Products.txt").toString();
        int start = 0, end;

        _products = new Vector();
        
        while((start=file.indexOf("ProductName: ", start))>=0) {
            Product p = new Product();
            start = start + "ProductName: ".length();
            end = file.indexOf("TagLine: ", start);
            p.productName = file.substring(start, end-1);
            start = end + "TagLine: ".length();
            end = file.indexOf("Copy: ", start);
            p.tagLine = file.substring(start, end-1);
            start = end + "Copy: ".length();
            end = file.indexOf("Price: ", start);
            p.copy = file.substring(start, end-1);
            start = end + "Price: ".length();
            end = file.indexOf("PartNumber: ", start);
            p.price = StringUtils.floatValue(file.substring(start, end-1));
            start = end + "PartNumber: ".length();
            end = file.indexOf("Image: ", start);
            p.partNumber = file.substring(start, end-1);
            start = end + "Image: ".length();
            end = file.indexOf("Layout: ", start);
            p.imagePath = path + "Images/" + file.substring(start, end-1);
            start = end + "Layout: ".length();
            end = file.indexOf("\n", start);
            p.layout = file.substring(start, end);
            _products.add(p);
        }
    }

    return _products;
}

static String rootPath(HttpServletRequest request)
{
   try { return request.getSession().getServletContext().getResource("/").getPath(); }
   catch(Exception e) { return "/"; }
}

static List randomize(List orig)
{
    int i, j, more = 0, added;

    List source = RMListUtils.clone(orig);
    List finalList = new Vector(source.size());
    
    while(source.size()>0) {
        i = _random.nextInt(source.size());
        Product item = (Product)source.get(i);
        String version = item.layout;
        finalList.add(item);
        source.remove(i);
        item.tableRowVersion = version;
        
        if(version.equals("FullPage"))
            more = 0;
        else if(version.equals("HalfPage"))
            more = 1;
        else if(version.equals("OneThirdPage"))
            more = 2;
            
        added = 0;
        
        while(more>added && source.size()>0) {
            i = _random.nextInt(source.size());
            j = i;
            
            Product newItem = null;
            
            do {
                if(((Product)source.get(j)).layout.equals(version)) {
                    newItem = (Product)source.get(j);
                    finalList.add(newItem);
                    source.remove(j);
                    ++added;
                    if(added%2 == 1)
                        newItem.tableRowVersion = version + "Alternate";
                    else newItem.tableRowVersion = version;
                    break;
                }
                
                else {
                    ++j;
                    if (j==source.size())
                        j = 0;
                }
            } while(j != i);
            
            if(newItem==null)
                break;
        }
        
        while(more>added) {
            String newVersion = version + "Empty" + (added%2==1? "" : "Alternate");
            Map m = RMMapUtils.newMap("tableRowVersion", newVersion);
            m.put("productName", "ReportMill (Advertisement)");
            finalList.add(m);
            added++;
        }
    }
  
    return finalList;
}

}